Subject: Re: [PATCH net] net: vxlan: fix crash when interface is created with no group

From: Mike Rapoport <[email-masked]>
Date: Fri, 28 Mar 2014 12:05:56 +0300

On Thu, Mar 27, 2014 at 01:20:25PM -0700, Cong Wang wrote:
> On Wed, Mar 26, 2014 at 10:50 AM, Mike Rapoport
> <[email-masked]> wrote:
> >
> > The problem is not only duplication of default destinations, but also
> > the mis^Wuse of default_dst to distinguish whether IPv4 or IPv6 path
> > should be taken because there is no explicit specification of the
> > protocol if neither IFLA_VXLAN_GROUP or IFLA_VXLAN_LOCAL defined at
> > vxlan_newlink. Moreover, if neither of these attributes is present, the
> > custom configuration will always use v4 socket regardles of use of
> > default_dst or fdb entry.
> 
> It should default to IPv4 for compatibility reason.

Yes, of course. The problem is that when IPv4 is not explicitly defined
using GROUP/LOCAL attributes, there are a lot of places that take IPv6
path.
So, what I'm proposing is to explicitly set default_dst family to
AF_INET and override it with AF_INET6 only when IPv6 is explicitly
requested.

--
Sincerely yours,
Mike.